﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@

#Event: ExampleEvent (Value As Int)
#DesignerProperty: Key: BooleanExample, DisplayName: Boolean Example, FieldType: Boolean, DefaultValue: True, Description: Example of a boolean property.
#DesignerProperty: Key: IntExample, DisplayName: Int Example, FieldType: Int, DefaultValue: 10, MinRange: 0, MaxRange: 100, Description: Note that MinRange and MaxRange are optional.
#DesignerProperty: Key: StringWithListExample, DisplayName: String With List, FieldType: String, DefaultValue: Sunday, List: Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday
#DesignerProperty: Key: StringExample, DisplayName: String Example, FieldType: String, DefaultValue: Text
#DesignerProperty: Key: ColorExample, DisplayName: Color Example, FieldType: Color, DefaultValue: 0xFFCFDCDC, Description: You can use the built-in color picker to find the color values.

Sub Class_Globals
	Private EventName As String 'ignore
	Private CallBack As Object 'ignore
	Private mBase As Panel
	Private edt As EditText
	Private FldTyp As Byte 
	Private ActiveTxtBoxBorderColor = Colors.RGB(128,0,0)
	Private InActiveTxtBoxBorderColor = Colors.ARGB(200,32,32,32)
	Private TxtBoxColor = Colors.White
	Private BorderWidth = 2 As Int
	Private Kyb As IME
	Dim TxtInpType As Int
	Dim InpTypCapWord = 8193 As Int
	Dim InpTypAllCap = 4097 As Int
	Dim InpTypFirstCap = 49153 As Int
	Dim InpTypNone = 1 As Int

	Public TypeText=1,TypeDate=2,TypeInt = 3,TypeFloat= 4,TypeCurrency=5 As Byte
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	EventName = vEventName
	CallBack = vCallback
	edt.Initialize("edt")
	edt.TextColor = Colors.Black
	setFieldType(TypeText)
End Sub

Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
	mBase = Base
	Private CD As ColorDrawable
	CD.Initialize2(TxtBoxColor,7,BorderWidth, InActiveTxtBoxBorderColor)
	Base.AddView( edt,0,0, Base.Width, Base.Height)
	Base.Background = CD
End Sub

Public Sub GetBase As Panel
	Return mBase
End Sub

Public Sub RequestFocus As Boolean
	edt.RequestFocus
End Sub

Public Sub getText As String
	Return edt.Text
End Sub

Public Sub setText(Val As String)
	edt.Text = Val
End Sub

Public Sub getView As EditText
	Return edt
End Sub

Public Sub setFieldType(Typ As Byte)
	FldTyp = Typ
	If(FldTyp = TypeText) Then
		edt.Gravity = Gravity.LEFT+Gravity.CENTER_VERTICAL
		edt.InputType = InpTypFirstCap
	else If(FldTyp = TypeInt Or FldTyp = TypeFloat Or FldTyp = TypeCurrency) Then
		edt.Gravity = Gravity.RIGHT+Gravity.CENTER_VERTICAL
		edt.Text = 0
	End If
End Sub

Private Sub edt_FocusChanged (HasFocus As Boolean)
	Private CD As ColorDrawable
	If HasFocus Then 	
		edt.SelectAll 		
			Kyb.ShowKeyboard(edt)
			CD.Initialize2(TxtBoxColor,7,BorderWidth, ActiveTxtBoxBorderColor)
	Else
		CD.Initialize2(TxtBoxColor,7,BorderWidth, InActiveTxtBoxBorderColor)
	End If
	mBase.Background = CD
End Sub

